Subject: bug#77916: Unicode Variation Selector 15 ignored by emacs GTK and honoured by emacs -nw

From: Дилян Палаузов<[email-masked]>
Date: Sat, 19 Apr 2025 15:51:59 +0300

Hello Eli,

thanks for your answer!

When emacs thinks in eww mode that a link is suspicious, it uses by default red background for blue text.  I think this is low contrast and therefore bad.  What I see is https://mail.aegee.org/dpa/island/emacs-gtk-warning-hyperlinks.png . The red is ff0000, the blue is 5452b2, or 3a5fcd (depending on where I click to select the colour), the contrast ratio is 1:62 or 1:1.42.

To be readable by everybody the contrast should be at least 1:3.

The terminal emulatior I am using is GNOME Terminal Version 3.54.4 GNOME 47 Using VTE version 0.78.4 +BIDI +GNUTLS +ICU +SYSTEMD.

If I start weston-terminal, I see no emojis.  koi8rxterm is even worse. uxterm (XTerm 397) and xterm (XTerm 397) show placeholders instead of emojis.

C-x C-u =  is below.  In all the output the clock is in colour.

Greetings
  Дилян

----

             position: 1292 of 1830 (71%), column: 5
            character: 🕛 (displayed as 🕛) (codepoint 128347, #o372533, #x1f55b)
              charset: unicode (Unicode (ISO10646))
code point in charset: 0x1F55B
               script: emoji
               syntax: w 	which means: word
             category: .:Base
             to input: type "C-x 8 RET 1f55b" or "C-x 8 RET CLOCK FACE TWELVE OCLOCK"
          buffer code: #xF0 #x9F #x95 #x9B
            file code: #xF0 #x9F #x95 #x9B (encoded by coding system utf-8-unix)
              display: composed to form "🕛︎" (see below)

Composed with the following character(s) "︎" using this font:
  ftcrhb:-GOOG-Noto Color Emoji-regular-normal-normal-*-14-*-*-*-m-0-iso10646-1
by these glyphs:
  [0 1 128347 826 17 0 18 13 4 nil]
  [0 1 65038 3 17 0 0 0 0 [0 0 0]]
with these character(s):
  ︎ (#xfe0e) VARIATION SELECTOR-15

Character code properties: customize what to show
  name: CLOCK FACE TWELVE OCLOCK
  general-category: So (Symbol, Other)
  decomposition: (128347) ('🕛')

There are text properties here:
  face                 shr-text

-----Original Message-----
From: Eli Zaretskii <[email-masked]>
To: Дилян Палаузов <[email-masked]>
Cc: [email-masked]
Subject: Re: bug#77916: Unicode Variation Selector 15 ignored by emacs GTK and honoured by emacs -nw
Date: 19/04/25 15:13:54

> From: Дилян Палаузов
> 	 <[email-masked]>
> Cc: [email-masked]
> Date: Sat, 19 Apr 2025 14:23:24 +0300
> 
> as image with the black hole is at https://mail.aegee.org/dpa/island/vc16-black-hole.png .

That seems to be a problem with the terminal emulator you are using?
It seems to ignore the background color of the face?

> With which font does it work?

It is easier for you to tell which font are you using with which it
doesn't work.  Use "C-u C-x =" at the buffer position of the clock to
show how Emacs displays that, and post here what it says in the *help*
buffer.

> The files https://cal.aegee.org/s/0/e947872a-224b-4c84-8d25-90a541a9ec6-318.ics_en.html  and https://mail.aegee.org/dpa/island/a.ics_en.html are identical, only the hosting domains are different.  But the two hyperlinks at the end of the file are shown differently, including colour and exclamation mark, both in GTK and -nw, when loaded via eww.

Ah, that's Emacs telling you that the link is suspicious.  Move the
mouse pointer to hover over the "warning" emoji, and Emacs will
explain the reason in a tooltip.

This is a feature, not a bug.

> Below I include the output of describe-fontset . Does it exlain why the clock is shown in colour?

No, but the output of "C-u C-x =" in the GTK session might.